#!/bin/sh
export PATH='/usr/local/sbin:/usr/local/bin:/usr/bin:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl'
echo 'name:                 binary-tagged
version:              0.2
visibility:           public
id:                   binary-tagged-0.2-5ZlsT7eG1ejJLIHgAtnpsQ
key:                  binary-tagged-0.2-5ZlsT7eG1ejJLIHgAtnpsQ
license:              BSD-3-Clause
maintainer:           Oleg Grenrus <oleg.grenrus@iki.fi>
author:               Oleg Grenrus <oleg.grenrus@iki.fi>
homepage:             https://github.com/phadej/binary-tagged#readme
synopsis:             Tagged binary serialisation.
description:
    Structurally tag binary serialisation stream.

    Say you have:

    @
    data Record = Record
    \  { _recordFields  :: HM.HashMap Text (Integer, ByteString)
    \  , _recordEnabled :: Bool
    \  }
    \  deriving (Eq, Show, Generic)

    instance Binary Record
    instance HasStructuralInfo Record
    instance HasSemanticVersion Record
    @

    then you can serialise and deserialise @Record@ values with a structure tag by simply

    @
    encodeTaggedFile "cachefile" record
    decodeTaggedFile "cachefile" :: IO Record
    @

    If structure of @Record@ changes in between, deserialisation will fail early.

    The overhead is next to non-observable, see [a simple benchmark](https://github.com/phadej/binary-tagged/blob/master/bench/Bench.hs).

    @
    benchmarking encode/Binary
    time                 362.6 μs   (361.2 μs .. 363.8 μs)

    benchmarking encode/Tagged
    time                 379.2 μs   (375.5 μs .. 382.2 μs)

    benchmarking decode/Binary
    time                 366.3 μs   (365.1 μs .. 368.1 μs)

    benchmarking decode/Tagged
    time                 367.6 μs   (367.0 μs .. 368.2 μs)
    @

category:             Data
abi:                  b14380e957b969735fcf0acdd719c193
exposed:              True
exposed-modules:      Data.Binary.Tagged
import-dirs:          /usr/lib/ghc-8.8.3/site-local/binary-tagged-0.2
library-dirs:         /usr/lib/ghc-8.8.3/site-local/binary-tagged-0.2
dynamic-library-dirs: /usr/lib
data-dir:             /usr/share/x86_64-linux-ghc-8.8.3/binary-tagged-0.2
hs-libraries:         HSbinary-tagged-0.2-5ZlsT7eG1ejJLIHgAtnpsQ
depends:
    aeson-1.4.7.0-6PzSaqxxzl7AIT9Pz5Kfsg array-0.5.4.0 base-4.13.0.0
    base16-bytestring-0.1.1.6-J3g2X7BxmtW2I6DRkwScma binary-0.8.7.0
    bytestring-0.10.10.0 containers-0.6.2.1
    cryptohash-sha1-0.11.100.1-61wOKcAgEzdBQ0CKgG6XHj
    generics-sop-0.5.0.0-F6YwC8rgK7PDSFuhTeyj9
    hashable-1.3.0.0-JbFSy8XBnx7GEc7vKlz2Jl
    scientific-0.3.6.2-HwSise45C5vHNs50sfVp6t
    tagged-0.8.6-LfhHZ57rMjK9JkdnSRh9cF text-1.2.4.0 time-1.9.3
    unordered-containers-0.2.10.0-LNKgKHyGmOAKxMaGgP4Zj6
    vector-0.12.1.2-C2W44iPdAFeHo4yLU081Gd

haddock-interfaces:
    /usr/share/doc/haskell-binary-tagged/html/binary-tagged.haddock

haddock-html:         /usr/share/doc/haskell-binary-tagged/html
' | '/usr/bin/ghc-pkg' 'update' '--force' '-' '--global' '--no-user-package-db' "$@"

